public class Lab7 {
  
  public static void main(String[] args) {
    
    int n = 10;       // for this simple example, we sort only n = 10 integers
    n++;                           // we place the items in A[1] through A[10]
    KeyType[ ] A = new KeyType[n];                     // let A be an array of
                                        // 10 items to sort, placed in A[1:10]
    
    // initialize the array A to ten integers to sort and print them
    for (int i = 1; i < n; i++) {
      A[i] = new KeyType( squareOf(3*i - 13) );
      System.out.print(A[i]+",  "); 
    }                                            // the unsorted integers are:
    System.out.println( );                 // 100,49,16,1,4,25,64,121,196, 289 

    // sort A using the HeapSort algorithm
    heapSort(A,n-1);    
    
    // print the values in the array A after sorting
    for (int i = 1; i < n; i++) {
      System.out.print(A[i]+",  "); 
    }                                              // the sorted integers are:
    System.out.println( );                 // 1,4,16,25,49,64,100,121,196, 289
    
  }     // end main
  
  
  // method for computing the square of x
  static int squareOf(int x) {                   
    return x*x; 
  }
  
  /* refine the following Program Strategy for heapSort */
  
  static void heapSort(KeyType[] A, int n) {
    
    KeyType temp;
    int i;
    
    (heapify all subtrees except the subtree containing the root) 
    (  using appropriate invocations of siftUp(A,i,n) in a for-statement)
        
        
    (reheapify starting at the root, remove the root, put it on the output)
    (queue and replace root with the last leaf in level order until the heap)
    (contains one key.)
              
  }   //end heapSort
  
  
  /* refine the following Program Strategy for the siftUp algorithm    */
  
  static void siftUp(KeyType[ ] A, int i, int n) {
    
    KeyType rootKey;
    boolean notFinished;
    int j;
    
    (let i point to the root and let n point to)
    (the last leaf in level order)
        
    (let rootKey be the key at the root)
          
    (let j point to the left child of i)
    (siftUp is not finished if j exists in the tree)
              
    (move any larger child that is bigger than the root upward)
    (one level in the tree)
    while (notFinished) {
      if (a right child of i also exists in the tree) {
	(set j to point to the larger child)
      }
      if (the larger child is not bigger than the root key) {
	(no more keys sift up)
      } else {
	(move larger child up one level in the tree.)
	(then, let i point to the larger child, j,)
	(and let j point to the new left child.)
	(siftUp is not finished if and only if j exists in the tree)
      }
    }     //end while
    
    (perform final placement of the root key)
      
  }   //end siftUp
  
} // end class Lab7



/*---------------------------------------------------------------------*/

interface ComparisonKey {
  
  // if k1 and k2 are ComparisonKeys, k1.compareTo(k2) is
  // 0, +1, or -1 according as k1 == k2, k1 > k2, or k1 < k2 in
  // the order of priority defined by the compareTo method
  
  int compareTo(ComparisonKey value);
  
  
  // converts item to printable string
  
  String toString();
  
}

/*---------------------------------------------------------------------*/

class KeyType implements ComparisonKey {
  
  // the data field contains an int giving the priority of the item
  
  int key;
  
  // the single int argument constructor sets the key to its argument
  
  KeyType(int value) {
    key = value; 
  }
  
  // the toString() method converts an integer key into a string
  
  public String toString() {
    return Integer.toString(key);       
  }
  
  // The k1.compareTo(k2) method is a three-way comparison of two
  // keys, k1 and k2, that returns 0, 1, and -1 when k1 == k2, k1 > k2,
  // and k1 < k2, respectively
  
  public int compareTo(ComparisonKey value) {
    int a = this.key;
    int b = ((KeyType)value).key;
    return ((a==b) ? 0 : ( (a > b) ? 1 : -1) );
  }
  
} // end KeyType
